// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ImageEnIO.pas' rev: 3.00

#ifndef ImageEnIOHPP
#define ImageEnIOHPP
#include <hyieutils.hpp>
#include <hyiedefs.hpp>
#include <ExtCtrls.hpp>
#include <ImageEnProc.hpp>
#include <ImageEnView.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Imageenio
{
//-- type declarations -------------------------------------------------------
struct TStreamJpegHeader
{
	char ID[5];
	int dim;
} ;

struct PCXSHead
{
	char ID[5];
	int dim;
} ;

struct TIFFSHead
{
	char ID[5];
	int dim;
} ;

enum ImageEnIO__1 { ppALL, ppAUTO, ppJPEG, ppTIFF, ppGIF, ppBMP, ppPCX, ppPNG, ppTGA };

typedef Set<ImageEnIO__1, ppALL, ppTGA>  TPreviewParams;

typedef void __fastcall (*TGIFLZWCompFunc)(Classes::TStream* Stream, int Height, int Width, bool Interlaced
	, char * FData, int BitsPerPixel);

typedef void __fastcall (*TGIFLZWDecompFunc)(Classes::TStream* Stream, int Height, int Width, bool Interlaced
	, char * FData);

typedef Windows::PByte __fastcall (*TTIFFLZWDecompFunc)(Windows::PByte CompBuf, int LineSize, int &Id
	);

typedef void __fastcall (*TTIFFLZWCompFunc)(Windows::PByte indata, int inputlen, Classes::TStream* outstream
	, int &id);

enum TIOPreviewsParamsItems { ioppDefaultLockPreview };

typedef Set<TIOPreviewsParamsItems, ioppDefaultLockPreview, ioppDefaultLockPreview>  TIOPreviewsParams
	;

enum TIOTIFFCompression { ioTIFF_UNCOMPRESSED, ioTIFF_CCITT1D, ioTIFF_G3FAX1D, ioTIFF_G3FAX2D, ioTIFF_G4FAX, 
	ioTIFF_LZW, ioTIFF_OLDJPEG, ioTIFF_JPEG, ioTIFF_PACKBITS };

enum TIOTIFFPhotometInterpret { ioTIFF_WHITEISZERO, ioTIFF_BLACKISZERO, ioTIFF_RGB, ioTIFF_RGBPALETTE, 
	ioTIFF_TRANSPMASK, ioTIFF_CMYK, ioTIFF_YCBCR, ioTIFF_CIELAB };

enum TIOJPEGColorspace { ioJPEG_RGB, ioJPEG_GRAYLEV, ioJPEG_YCbCr, ioJPEG_CMYK, ioJPEG_YCbCrK };

enum TIOJPEGDctMethod { ioJPEG_ISLOW, ioJPEG_IFAST, ioJPEG_FLOAT };

enum TIOJPEGScale { ioJPEG_AUTOCALC, ioJPEG_FULLSIZE, ioJPEG_HALF, ioJPEG_QUARTER, ioJPEG_EIGHTH };

enum TIOBMPVersion { ioBMP_BM, ioBMP_BM3, ioBMP_BMOS2V1, ioBMP_BMOS2V2 };

enum TIOBMPCompression { ioBMP_UNCOMPRESSED, ioBMP_RLE };

enum TIOPCXCompression { ioPCX_UNCOMPRESSED, ioPCX_RLE };

enum TIOPNGFilter { ioPNG_FILTER_NONE, ioPNG_FILTER_SUB, ioPNG_FILTER_PAETH };

typedef int TIOFileType;

class DELPHICLASS TIOParamsVals;
class DELPHICLASS TImageEnIO;
class DELPHICLASS TIETWainParams;
struct TIEDRect
{
	double Left;
	double Top;
	double Right;
	double Bottom;
} ;

struct TIETWSourceCaps
{
	Hyieutils::TIEDoubleList* fXResolution;
	Hyieutils::TIEDoubleList* fYResolution;
	Hyieutils::TIEDoubleList* fXScaling;
	Hyieutils::TIEDoubleList* fYScaling;
	Hyieutils::TIEIntegerList* fPixelType;
	double fGamma;
	double fPhysicalHeight;
	double fPhysicalWidth;
	bool fFeederEnabled;
	Hyieutils::TIEIntegerList* fOrientation;
	bool fIndicators;
	TIEDRect fAcquireFrame;
	bool fBufferedTransfer;
	bool fDuplexEnabled;
	bool fAcquireFrameEnabled;
} ;

class PASCALIMPLEMENTATION TIETWainParams : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TComponent* fOwner;
	bool fVisibleDialog;
	Classes::TList* fSourceListData;
	int fSelectedSource;
	bool fSourceListDataValid;
	bool fCapabilitiesValid;
	TIETWSourceCaps fCapabilities;
	System::AnsiString fAppVersionInfo;
	System::AnsiString fAppManufacturer;
	System::AnsiString fAppProductFamily;
	System::AnsiString fAppProductName;
	void __fastcall FillSourceListData(void);
	void __fastcall FillCapabilities(void);
	System::AnsiString __fastcall GetSourceName(int idx);
	int __fastcall GetSourceCount(void);
	Hyieutils::TIEDoubleList* __fastcall GetXResolution(void);
	Hyieutils::TIEDoubleList* __fastcall GetYResolution(void);
	Hyieutils::TIEDoubleList* __fastcall GetXScaling(void);
	Hyieutils::TIEDoubleList* __fastcall GetYScaling(void);
	Hyieutils::TIEIntegerList* __fastcall GetPixelType(void);
	double __fastcall GetGamma(void);
	double __fastcall GetPhysicalHeight(void);
	double __fastcall GetPhysicalWidth(void);
	bool __fastcall GetFeederEnabled(void);
	Hyieutils::TIEIntegerList* __fastcall GetOrientation(void);
	void __fastcall SetSelectedSource(int v);
	bool __fastcall GetIndicators(void);
	void __fastcall SetFeederEnabled(bool v);
	void __fastcall SetIndicators(bool v);
	double __fastcall GetAcquireFrame(int idx);
	void __fastcall SetAcquireFrame(int idx, double v);
	bool __fastcall GetBufferedTransfer(void);
	void __fastcall SetBufferedTransfer(bool v);
	void __fastcall SetAppVersionInfo(System::AnsiString v);
	void __fastcall SetAppManufacturer(System::AnsiString v);
	void __fastcall SetAppProductFamily(System::AnsiString v);
	void __fastcall SetAppProductName(System::AnsiString v);
	void __fastcall SetDuplexEnabled(bool v);
	bool __fastcall GetDuplexEnabled(void);
	void __fastcall SetAcquireFrameEnabled(bool v);
	bool __fastcall GetAcquireFrameEnabled(void);
	
public:
	__property bool VisibleDialog = {read=fVisibleDialog, write=fVisibleDialog, nodefault};
	__property System::AnsiString SourceName[int idx] = {read=GetSourceName};
	__property int SourceCount = {read=GetSourceCount, nodefault};
	__property int SelectedSource = {read=fSelectedSource, write=SetSelectedSource, nodefault};
	__property Hyieutils::TIEDoubleList* XResolution = {read=GetXResolution};
	__property Hyieutils::TIEDoubleList* YResolution = {read=GetYResolution};
	__property Hyieutils::TIEDoubleList* XScaling = {read=GetXScaling};
	__property Hyieutils::TIEDoubleList* YScaling = {read=GetYScaling};
	__property Hyieutils::TIEIntegerList* PixelType = {read=GetPixelType};
	__property double Gamma = {read=GetGamma};
	__property double PhysicalHeight = {read=GetPhysicalHeight};
	__property double PhysicalWidth = {read=GetPhysicalWidth};
	__property bool FeederEnabled = {read=GetFeederEnabled, write=SetFeederEnabled, nodefault};
	__property Hyieutils::TIEIntegerList* Orientation = {read=GetOrientation};
	__property bool ProgressIndicators = {read=GetIndicators, write=SetIndicators, nodefault};
	__property double AcquireFrameLeft = {read=GetAcquireFrame, write=SetAcquireFrame, index=0};
	__property double AcquireFrameTop = {read=GetAcquireFrame, write=SetAcquireFrame, index=1};
	__property double AcquireFrameRight = {read=GetAcquireFrame, write=SetAcquireFrame, index=2};
	__property double AcquireFrameBottom = {read=GetAcquireFrame, write=SetAcquireFrame, index=3};
	__property bool BufferedTransfer = {read=GetBufferedTransfer, write=SetBufferedTransfer, nodefault}
		;
	__property bool DuplexEnabled = {read=GetDuplexEnabled, write=SetDuplexEnabled, nodefault};
	__property bool AcquireFrameEnabled = {read=GetAcquireFrameEnabled, write=SetAcquireFrameEnabled, nodefault
		};
	__property System::AnsiString AppVersionInfo = {read=fAppVersionInfo, write=SetAppVersionInfo};
	__property System::AnsiString AppManufacturer = {read=fAppManufacturer, write=SetAppManufacturer};
	__property System::AnsiString AppProductFamily = {read=fAppProductFamily, write=SetAppProductFamily
		};
	__property System::AnsiString AppProductName = {read=fAppProductName, write=SetAppProductName};
	__fastcall TIETWainParams(Classes::TComponent* Owner);
	__fastcall virtual ~TIETWainParams(void);
	void __fastcall SetDefaultParams(void);
	void __fastcall Assign(TIETWainParams* Source);
	bool __fastcall SelectSourceByName(const System::AnsiString sn);
	void __fastcall Update(void);
};

typedef void __fastcall (__closure *TIEIOPreviewEvent)(System::TObject* Sender, Forms::TForm* PreviewForm
	);

class PASCALIMPLEMENTATION TImageEnIO : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TBitmap* fBitmap;
	Imageenview::TIEView* fImageEnView;
	Extctrls::TImage* fTImage;
	Graphics::TColor fBackground;
	TMsgLanguage fMsgLanguage;
	TIOPreviewsParams fPreviewsParams;
	TIETWainParams* fTwainParams;
	bool fStreamHeaders;
	Graphics::TFont* fPreviewFont;
	TIEIOPreviewEvent fOnIOPreview;
	void __fastcall SetAttachedBitmap(Graphics::TBitmap* atBitmap);
	void __fastcall SetAttachedImageEn(Imageenview::TIEView* atImageEn);
	Graphics::TColor __fastcall GetReBackground(void);
	void __fastcall SetReBackground(Graphics::TColor v);
	void __fastcall Clear(void);
	void __fastcall SetPreviewFont(Graphics::TFont* f);
	void __fastcall SetTImage(Extctrls::TImage* v);
	void __fastcall SetIOPreviewParams(TIOPreviewsParams v);
	TIOPreviewsParams __fastcall GetIOPreviewParams(void);
	
protected:
	TIOParamsVals* fParams;
	bool fAborting;
	Hyiedefs::TIEProgressEvent fOnProgress;
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	void __fastcall OnBitmapChange(System::TObject* Sender, bool destroying);
	
public:
	__fastcall virtual TImageEnIO(Classes::TComponent* Owner);
	__fastcall virtual ~TImageEnIO(void);
	__property Graphics::TBitmap* AttachedBitmap = {read=fBitmap, write=SetAttachedBitmap};
	void __fastcall Update(void);
	bool __fastcall DoPreviews(TPreviewParams pp);
	__property Graphics::TBitmap* Bitmap = {read=fBitmap, write=fBitmap};
	__property TIOParamsVals* Params = {read=fParams};
	void __fastcall AssignParams(System::TObject* Source);
	void __fastcall SaveToFileJpeg(const System::AnsiString nf);
	void __fastcall LoadFromFileJpeg(const System::AnsiString nf);
	void __fastcall SaveToStreamJpeg(Classes::TStream* Stream);
	void __fastcall LoadFromStreamJpeg(Classes::TStream* Stream);
	int __fastcall LoadFromFileGif(const System::AnsiString nf);
	void __fastcall SaveToFileGif(const System::AnsiString nf);
	int __fastcall InsertToFileGif(const System::AnsiString nf);
	int __fastcall LoadFromStreamGif(Classes::TStream* Stream);
	void __fastcall SaveToStreamGif(Classes::TStream* Stream);
	void __fastcall SaveToStreamPCX(Classes::TStream* Stream);
	void __fastcall LoadFromStreamPCX(Classes::TStream* Stream);
	void __fastcall SaveToFilePCX(const System::AnsiString nf);
	void __fastcall LoadFromFilePCX(const System::AnsiString nf);
	int __fastcall LoadFromStreamTIFF(Classes::TStream* Stream);
	void __fastcall SaveToStreamTIFF(Classes::TStream* Stream);
	int __fastcall LoadFromFileTIFF(const System::AnsiString nf);
	void __fastcall SaveToFileTIFF(const System::AnsiString nf);
	int __fastcall InsertToFileTIFF(const System::AnsiString nf);
	void __fastcall SaveToStreamBMP(Classes::TStream* Stream);
	void __fastcall LoadFromStreamBMP(Classes::TStream* Stream);
	void __fastcall SaveToFileBMP(const System::AnsiString nf);
	void __fastcall LoadFromFileBMP(const System::AnsiString nf);
	void __fastcall LoadFromFileICO(const System::AnsiString nf);
	void __fastcall LoadFromStreamICO(Classes::TStream* Stream);
	void __fastcall LoadFromFileCUR(const System::AnsiString nf);
	void __fastcall LoadFromStreamCUR(Classes::TStream* Stream);
	void __fastcall LoadFromFilePNG(const System::AnsiString nf);
	void __fastcall LoadFromStreamPNG(Classes::TStream* Stream);
	void __fastcall SaveToFilePNG(const System::AnsiString nf);
	void __fastcall SaveToStreamPNG(Classes::TStream* Stream);
	void __fastcall LoadFromFileTGA(const System::AnsiString nf);
	void __fastcall LoadFromStreamTGA(Classes::TStream* Stream);
	void __fastcall SaveToFileTGA(const System::AnsiString nf);
	void __fastcall SaveToStreamTGA(Classes::TStream* Stream);
	void __fastcall ImportMetafile(const System::AnsiString nf, int Width, int Height);
	DYNAMIC void __fastcall LoadFromFile(const System::AnsiString nf);
	DYNAMIC void __fastcall SaveToFile(const System::AnsiString nf);
	DYNAMIC void __fastcall LoadFromFileFormat(const System::AnsiString nf, int FileFormat);
	__property bool Aborting = {read=fAborting, write=fAborting, nodefault};
	DYNAMIC void __fastcall ParamsFromFile(const System::AnsiString nf);
	DYNAMIC void __fastcall ParamsFromStream(Classes::TStream* Stream);
	DYNAMIC void __fastcall LoadFromStream(Classes::TStream* Stream);
	DYNAMIC void __fastcall LoadFromStreamFormat(Classes::TStream* Stream, int FileFormat);
	DYNAMIC void __fastcall SaveToStream(Classes::TStream* Stream, int FileType);
	bool __fastcall Acquire(void);
	bool __fastcall SelectAcquireSource(void);
	__property TIETWainParams* TWainParams = {read=fTwainParams};
	
__published:
	__property Imageenview::TIEView* AttachedImageEn = {read=fImageEnView, write=SetAttachedImageEn};
	__property Graphics::TColor Background = {read=GetReBackground, write=SetReBackground, default=0};
	__property Hyiedefs::TIEProgressEvent OnProgress = {read=fOnProgress, write=fOnProgress};
	__property Hyiedefs::TMsgLanguage MsgLanguage = {read=fMsgLanguage, write=fMsgLanguage, default=0};
		
	__property TIOPreviewsParams PreviewsParams = {read=GetIOPreviewParams, write=SetIOPreviewParams, default=0
		};
	__property bool StreamHeaders = {read=fStreamHeaders, write=fStreamHeaders, default=0};
	__property Graphics::TFont* PreviewFont = {read=fPreviewFont, write=SetPreviewFont};
	__property Extctrls::TImage* AttachedTImage = {read=fTImage, write=SetTImage};
	__property TIEIOPreviewEvent OnIOPreview = {read=fOnIOPreview, write=fOnIOPreview};
};

class PASCALIMPLEMENTATION TIOParamsVals : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TImageEnIO* fImageEnIO;
	int fBitsPerSample;
	int fSamplesPerPixel;
	int fWidth;
	int fHeight;
	int fDpiX;
	int fDpiY;
	int fFileType;
	TIOTIFFCompression fTIFF_Compression;
	int fTIFF_ImageIndex;
	TIOTIFFPhotometInterpret fTIFF_PhotometInterpret;
	int fTIFF_PlanarConf;
	int fTIFF_XPos;
	int fTIFF_YPos;
	System::AnsiString fTIFF_DocumentName;
	System::AnsiString fTIFF_ImageDescription;
	System::AnsiString fTIFF_PageName;
	int fTIFF_PageNumber;
	int fTIFF_PageCount;
	TTIFFLZWDecompFunc fTIFF_LZWDecompFunc;
	TTIFFLZWCompFunc fTIFF_LZWCompFunc;
	System::AnsiString fGIF_Version;
	int fGIF_ImageIndex;
	int fGIF_XPos;
	int fGIF_YPos;
	int fGIF_DelayTime;
	bool fGIF_FlagTranspColor;
	Hyiedefs::TRGB fGIF_TranspColor;
	bool fGIF_Interlaced;
	int fGIF_WinWidth;
	int fGIF_WinHeight;
	Hyiedefs::TRGB fGIF_Background;
	int fGIF_Ratio;
	TGIFLZWDecompFunc fGIF_LZWDecompFunc;
	TGIFLZWCompFunc fGIF_LZWCompFunc;
	TIOJPEGColorspace fJPEG_ColorSpace;
	int fJPEG_Quality;
	TIOJPEGDctMethod fJPEG_DCTMethod;
	bool fJPEG_OptimalHuffman;
	int fJPEG_Smooth;
	bool fJPEG_Progressive;
	TIOJPEGScale fJPEG_Scale;
	Hyieutils::TIEMarkerList* fJPEG_MarkerList;
	int fPCX_Version;
	TIOPCXCompression fPCX_Compression;
	TIOBMPVersion fBMP_Version;
	TIOBMPCompression fBMP_Compression;
	int fICO_ImageIndex;
	Hyiedefs::TRGB fICO_Background;
	int fCUR_ImageIndex;
	int fCUR_XHotSpot;
	int fCUR_YHotSpot;
	Hyiedefs::TRGB fCUR_Background;
	bool fPNG_Interlaced;
	Hyiedefs::TRGB fPNG_Background;
	TIOPNGFilter fPNG_Filter;
	int fPNG_Compression;
	int fTGA_XPos;
	int fTGA_YPos;
	bool fTGA_Compressed;
	System::AnsiString fTGA_Descriptor;
	System::AnsiString fTGA_Author;
	System::TDateTime fTGA_Date;
	System::AnsiString fTGA_ImageName;
	Hyiedefs::TRGB fTGA_Background;
	double fTGA_AspectRatio;
	double fTGA_Gamma;
	bool fTGA_GrayLevel;
	Hyieutils::TIEIPTCInfoList* fIPTC_Info;
	System::AnsiString __fastcall GetFileTypeStr(void);
	
public:
	System::AnsiString fFileName;
	Hyiedefs::RGBROW *fColorMap;
	int fColorMapCount;
	int fGIF_ImageCount;
	int fTIFF_ImageCount;
	__property System::AnsiString FileName = {read=fFileName};
	__property System::AnsiString FileTypeStr = {read=GetFileTypeStr};
	__property int FileType = {read=fFileType, write=fFileType, nodefault};
	__property int BitsPerSample = {read=fBitsPerSample, write=fBitsPerSample, nodefault};
	__property int SamplesPerPixel = {read=fSamplesPerPixel, write=fSamplesPerPixel, nodefault};
	__property int Width = {read=fWidth, write=fWidth, nodefault};
	__property int Height = {read=fHeight, write=fHeight, nodefault};
	__property int DpiX = {read=fDpiX, write=fDpiX, nodefault};
	__property int DpiY = {read=fDpiY, write=fDpiY, nodefault};
	__property Hyiedefs::pRGBROW ColorMap = {read=fColorMap};
	__property int ColorMapCount = {read=fColorMapCount, nodefault};
	__property Hyieutils::TIEIPTCInfoList* IPTC_Info = {read=fIPTC_Info};
	__property TIOTIFFCompression TIFF_Compression = {read=fTIFF_Compression, write=fTIFF_Compression, 
		nodefault};
	__property int TIFF_ImageIndex = {read=fTIFF_ImageIndex, write=fTIFF_ImageIndex, nodefault};
	__property int TIFF_ImageCount = {read=fTIFF_ImageCount, nodefault};
	__property TIOTIFFPhotometInterpret TIFF_PhotometInterpret = {read=fTIFF_PhotometInterpret, write=fTIFF_PhotometInterpret
		, nodefault};
	__property int TIFF_PlanarConf = {read=fTIFF_PlanarConf, write=fTIFF_PlanarConf, nodefault};
	__property int TIFF_XPos = {read=fTIFF_XPos, write=fTIFF_XPos, nodefault};
	__property int TIFF_YPos = {read=fTIFF_YPos, write=fTIFF_YPos, nodefault};
	__property System::AnsiString TIFF_DocumentName = {read=fTIFF_DocumentName, write=fTIFF_DocumentName
		};
	__property System::AnsiString TIFF_ImageDescription = {read=fTIFF_ImageDescription, write=fTIFF_ImageDescription
		};
	__property System::AnsiString TIFF_PageName = {read=fTIFF_PageName, write=fTIFF_PageName};
	__property int TIFF_PageNumber = {read=fTIFF_PageNumber, write=fTIFF_PageNumber, nodefault};
	__property int TIFF_PageCount = {read=fTIFF_PageCount, write=fTIFF_PageCount, nodefault};
	__property TTIFFLZWDecompFunc TIFF_LZWDecompFunc = {read=fTIFF_LZWDecompFunc, write=fTIFF_LZWDecompFunc
		};
	__property TTIFFLZWCompFunc TIFF_LZWCompFunc = {read=fTIFF_LZWCompFunc, write=fTIFF_LZWCompFunc};
	__property System::AnsiString GIF_Version = {read=fGIF_Version, write=fGIF_Version};
	__property int GIF_ImageIndex = {read=fGIF_ImageIndex, write=fGIF_ImageIndex, nodefault};
	__property int GIF_ImageCount = {read=fGIF_ImageCount, nodefault};
	__property int GIF_XPos = {read=fGIF_XPos, write=fGIF_XPos, nodefault};
	__property int GIF_YPos = {read=fGIF_YPos, write=fGIF_YPos, nodefault};
	__property int GIF_DelayTime = {read=fGIF_DelayTime, write=fGIF_DelayTime, nodefault};
	__property bool GIF_FlagTranspColor = {read=fGIF_FlagTranspColor, write=fGIF_FlagTranspColor, nodefault
		};
	__property Hyiedefs::TRGB GIF_TranspColor = {read=fGIF_TranspColor, write=fGIF_TranspColor};
	__property bool GIF_Interlaced = {read=fGIF_Interlaced, write=fGIF_Interlaced, nodefault};
	__property int GIF_WinWidth = {read=fGIF_WinWidth, write=fGIF_WinWidth, nodefault};
	__property int GIF_WinHeight = {read=fGIF_WinHeight, write=fGIF_WinHeight, nodefault};
	__property Hyiedefs::TRGB GIF_Background = {read=fGIF_Background, write=fGIF_Background};
	__property int GIF_Ratio = {read=fGIF_Ratio, write=fGIF_Ratio, nodefault};
	__property TGIFLZWDecompFunc GIF_LZWDecompFunc = {read=fGIF_LZWDecompFunc, write=fGIF_LZWDecompFunc
		};
	__property TGIFLZWCompFunc GIF_LZWCompFunc = {read=fGIF_LZWCompFunc, write=fGIF_LZWCompFunc};
	__property TIOJPEGColorspace JPEG_ColorSpace = {read=fJPEG_ColorSpace, write=fJPEG_ColorSpace, nodefault
		};
	__property int JPEG_Quality = {read=fJPEG_Quality, write=fJPEG_Quality, nodefault};
	__property TIOJPEGDctMethod JPEG_DCTMethod = {read=fJPEG_DCTMethod, write=fJPEG_DCTMethod, nodefault
		};
	__property bool JPEG_OptimalHuffman = {read=fJPEG_OptimalHuffman, write=fJPEG_OptimalHuffman, nodefault
		};
	__property int JPEG_Smooth = {read=fJPEG_Smooth, write=fJPEG_Smooth, nodefault};
	__property bool JPEG_Progressive = {read=fJPEG_Progressive, write=fJPEG_Progressive, nodefault};
	__property TIOJPEGScale JPEG_Scale = {read=fJPEG_Scale, write=fJPEG_Scale, nodefault};
	__property Hyieutils::TIEMarkerList* JPEG_MarkerList = {read=fJPEG_MarkerList};
	__property int PCX_Version = {read=fPCX_Version, write=fPCX_Version, nodefault};
	__property TIOPCXCompression PCX_Compression = {read=fPCX_Compression, write=fPCX_Compression, nodefault
		};
	__property TIOBMPVersion BMP_Version = {read=fBMP_Version, write=fBMP_Version, nodefault};
	__property TIOBMPCompression BMP_Compression = {read=fBMP_Compression, write=fBMP_Compression, nodefault
		};
	__property int ICO_ImageIndex = {read=fICO_ImageIndex, write=fICO_ImageIndex, nodefault};
	__property Hyiedefs::TRGB ICO_Background = {read=fICO_Background, write=fICO_Background};
	__property int CUR_ImageIndex = {read=fCUR_ImageIndex, write=fCUR_ImageIndex, nodefault};
	__property int CUR_XHotSpot = {read=fCUR_XHotSpot, write=fCUR_XHotSpot, nodefault};
	__property int CUR_YHotSpot = {read=fCUR_YHotSpot, write=fCUR_YHotSpot, nodefault};
	__property Hyiedefs::TRGB CUR_Background = {read=fCUR_Background, write=fCUR_Background};
	__property bool PNG_Interlaced = {read=fPNG_Interlaced, write=fPNG_Interlaced, nodefault};
	__property Hyiedefs::TRGB PNG_Background = {read=fPNG_Background, write=fPNG_Background};
	__property TIOPNGFilter PNG_Filter = {read=fPNG_Filter, write=fPNG_Filter, nodefault};
	__property int PNG_Compression = {read=fPNG_Compression, write=fPNG_Compression, nodefault};
	__property int TGA_XPos = {read=fTGA_XPos, write=fTGA_XPos, nodefault};
	__property int TGA_YPos = {read=fTGA_YPos, write=fTGA_YPos, nodefault};
	__property bool TGA_Compressed = {read=fTGA_Compressed, write=fTGA_Compressed, nodefault};
	__property System::AnsiString TGA_Descriptor = {read=fTGA_Descriptor, write=fTGA_Descriptor};
	__property System::AnsiString TGA_Author = {read=fTGA_Author, write=fTGA_Author};
	__property System::TDateTime TGA_Date = {read=fTGA_Date, write=fTGA_Date};
	__property System::AnsiString TGA_ImageName = {read=fTGA_ImageName, write=fTGA_ImageName};
	__property Hyiedefs::TRGB TGA_Background = {read=fTGA_Background, write=fTGA_Background};
	__property double TGA_AspectRatio = {read=fTGA_AspectRatio, write=fTGA_AspectRatio};
	__property double TGA_Gamma = {read=fTGA_Gamma, write=fTGA_Gamma};
	__property bool TGA_GrayLevel = {read=fTGA_GrayLevel, write=fTGA_GrayLevel, nodefault};
	__fastcall TIOParamsVals(TImageEnIO* IEIO);
	__fastcall virtual ~TIOParamsVals(void);
	void __fastcall SetDefaultParams(void);
	void __fastcall Assign(TIOParamsVals* Source);
	void __fastcall SaveToFile(const System::AnsiString FileName);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall LoadFromFile(const System::AnsiString FileName);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
};

typedef void __fastcall (*TIEReadImageStream)(Classes::TStream* Stream, Graphics::TBitmap* Bitmap, TIOParamsVals* 
	&IOParams, Hyiedefs::TProgressRec &Progress, bool Preview);

typedef void __fastcall (*TIEWriteImageStream)(Classes::TStream* Stream, Graphics::TBitmap* Bitmap, 
	TIOParamsVals* &IOParams, Hyiedefs::TProgressRec &Progress);

typedef bool __fastcall (*TIETryImageStream)(Classes::TStream* Stream);

struct TIEFileFormatInfo
{
	int FileType;
	System::SmallString<80>  FullName;
	System::SmallString<80>  Extensions;
	TIEReadImageStream ReadFunction;
	TIEWriteImageStream WriteFunction;
	TIETryImageStream TryFunction;
} ;

typedef TIEFileFormatInfo *PIEFileFormatInfo;

//-- var, const, procedure ---------------------------------------------------
#define ioUnknown (Byte)(0)
#define ioTIFF (Byte)(1)
#define ioGIF (Byte)(2)
#define ioJPEG (Byte)(3)
#define ioPCX (Byte)(4)
#define ioBMP (Byte)(5)
#define ioICO (Byte)(6)
#define ioCUR (Byte)(7)
#define ioPNG (Byte)(8)
#define ioWMF (Byte)(9)
#define ioEMF (Byte)(10)
#define ioTGA (Byte)(11)
#define ioUSER (Word)(10000)
#define JPEG_APP0 (Byte)(224)
#define JPEG_APP1 (Byte)(225)
#define JPEG_APP2 (Byte)(226)
#define JPEG_APP3 (Byte)(227)
#define JPEG_APP4 (Byte)(228)
#define JPEG_APP5 (Byte)(229)
#define JPEG_APP6 (Byte)(230)
#define JPEG_APP7 (Byte)(231)
#define JPEG_APP8 (Byte)(232)
#define JPEG_APP9 (Byte)(233)
#define JPEG_APP10 (Byte)(234)
#define JPEG_APP11 (Byte)(235)
#define JPEG_APP12 (Byte)(236)
#define JPEG_APP13 (Byte)(237)
#define JPEG_APP14 (Byte)(238)
#define JPEG_APP15 (Byte)(239)
#define JPEG_COM (Byte)(254)
extern PACKAGE TGIFLZWDecompFunc DefGIF_LZWDECOMPFUNC;
extern PACKAGE TGIFLZWCompFunc DefGIF_LZWCOMPFUNC;
extern PACKAGE TTIFFLZWDecompFunc DefTIFF_LZWDECOMPFUNC;
extern PACKAGE TTIFFLZWCompFunc DefTIFF_LZWCOMPFUNC;
extern PACKAGE Classes::TList* iegFileFormats;
extern PACKAGE int __fastcall DeleteGifIm(const System::AnsiString nf, int idx);
extern PACKAGE int __fastcall DeleteTIFFIm(const System::AnsiString nf, int idx);
extern PACKAGE int __fastcall EnumGifIm(const System::AnsiString nf);
extern PACKAGE int __fastcall EnumTIFFIm(const System::AnsiString nf);
extern PACKAGE bool __fastcall CheckAniGif(const System::AnsiString nf);
extern PACKAGE int __fastcall FindFileFormat(const System::AnsiString nf, bool VerifyExtension);
extern PACKAGE int __fastcall FindStreamFormat(Classes::TStream* fs);
extern PACKAGE PIEFileFormatInfo __fastcall IEFileFormatGetInfo(int FileType);
extern PACKAGE int __fastcall IEFileFormatGetExtCount(int FileType);
extern PACKAGE System::AnsiString __fastcall IEFileFormatGetExt(int FileType, int idx);
extern PACKAGE PIEFileFormatInfo __fastcall IEFileFormatGetInfo2(System::AnsiString Extension);
extern PACKAGE void __fastcall IEFileFormatAdd(const TIEFileFormatInfo &FileFormatInfo);
extern PACKAGE void __fastcall IEFileFormatRemove(int FileType);

}	/* namespace Imageenio */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Imageenio;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ImageEnIO
